ru.bitel.bgbilling.modules.sorm.common.service

## Interface SormService

-     public interface SormService

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clearStatisticOfProject(int sormProjectId)` Удаление статистики для проекта СОРМ
    `void` | `deleteSormProject(int id)` Удаляет проект(выгрузку) СОРМ по его id
    `java.util.List<SormProject>` | `getActiveSormProject()` Возвращает список включенных для выгрузки проекта СОРМ
    `java.util.List<IdTitle>` | `getBillAttributeTypeList()`
    `java.util.List<InstalledInstanceModule>` | `getInstalledEthernetModules()` Возвращает список установленных экземпляров модулей интернета
    `java.util.List<InstalledInstanceModule>` | `getInstalledPhoneModules()` Возвращает список установленных экземпляров модулей телефонии
    `java.util.List<InstalledInstanceModule>` | `getInstalledSormModules()` Возвращает список установленных модулей, по которым может быть выполнена выгрузка для СОРМ
    `java.util.List<InstalledInstanceModule>` | `getInstanceModules(java.lang.String moduleName)` Возвращает список установленных экземпляров модулей по переданному имени модуля
    `java.util.List<IdTitle>` | `getNumberResourceCategoryList(int mid)` Возвращает лист категорий номеров модуля Phone, без выстраивания дерева
    `SormProject` | `getSormProject(int id)`
    `java.util.List<SormProject>` | `getSormProjects()`
    `SearchResult<SormUploadStatistic>` | `getStatisticOfProject(int sormProjectId, Page page)`
    `java.util.List<IdTitle>` | `listObjectParamsByObjectType(int objectTypeId)`
    `java.util.List<IdTitle>` | `listObjectType()`
    `void` | `startFullUpload(SormProject sormProject, boolean withPayments)` Запуск единоразовой полной выгрузки СОРМ
    `void` | `startUpload(SormProject sormProject, boolean withPayments)` Запуск единоразовой инкрементальной выгрузки СОРМ
    `void` | `tryUploadToFTPAgain(SormUploadStatistic statistic)` Попытка снова выгрузить файлы на фтп для неудачной выгрузки.
    `void` | `updateSormProject(SormProject sormProject)` Обновляет или добавляет проект(выгрузку) СОРМ

- - ### Method Detail

    - #### getInstalledSormModules

          java.util.List<InstalledInstanceModule> getInstalledSormModules()

      Возвращает список установленных модулей, по которым может быть выполнена выгрузка для СОРМ
      Returns:

    - #### getInstalledEthernetModules

          java.util.List<InstalledInstanceModule> getInstalledEthernetModules()

      Возвращает список установленных экземпляров модулей интернета
      Returns:

    - #### getInstalledPhoneModules

          java.util.List<InstalledInstanceModule> getInstalledPhoneModules()

      Возвращает список установленных экземпляров модулей телефонии
      Returns:

    - #### getInstanceModules

          java.util.List<InstalledInstanceModule> getInstanceModules(java.lang.String moduleName)

      Возвращает список установленных экземпляров модулей по переданному имени модуля
      Parameters:
        `moduleName` - - имя искомого модуля, например bill или npay
      Returns:

    - #### getBillAttributeTypeList

          java.util.List<IdTitle> getBillAttributeTypeList()
                                                    throws ru.bitel.bgbilling.common.BGException

      Returns:
        типы аттрибутов заведенных в модуле бухгалтерия
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getSormProjects

          java.util.List<SormProject> getSormProjects()
                                               throws ru.bitel.bgbilling.common.BGException

      Returns:
        список проектов СОРМ
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getSormProject

          SormProject getSormProject(int id)
                              throws ru.bitel.bgbilling.common.BGException

      Returns:
        проект(выгрузку) СОРМ по id
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### updateSormProject

          void updateSormProject(SormProject sormProject)
                          throws ru.bitel.bgbilling.common.BGException

      Обновляет или добавляет проект(выгрузку) СОРМ
      Parameters:
        `sormProject` - - проект СОРМ
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### deleteSormProject

          void deleteSormProject(int id)
                          throws ru.bitel.bgbilling.common.BGException

      Удаляет проект(выгрузку) СОРМ по его id
      Parameters:
        `id` - - id удаляемого проекта(выгрузки)
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getNumberResourceCategoryList

          java.util.List<IdTitle> getNumberResourceCategoryList(int mid)

      Возвращает лист категорий номеров модуля Phone, без выстраивания дерева
      Returns:

    - #### getActiveSormProject

          java.util.List<SormProject> getActiveSormProject()
                                                    throws ru.bitel.bgbilling.common.BGException

      Возвращает список включенных для выгрузки проекта СОРМ
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### startUpload

          void startUpload(SormProject sormProject,
                           boolean withPayments)
                    throws ru.bitel.bgbilling.common.BGException

      Запуск единоразовой инкрементальной выгрузки СОРМ
      Parameters:
        `sormProject` - - проект СОРМ, для которого необходимо начать выгрузку
        `withPayments` - - c платежами или без
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### startFullUpload

          void startFullUpload(SormProject sormProject,
                               boolean withPayments)
                        throws ru.bitel.bgbilling.common.BGException

      Запуск единоразовой полной выгрузки СОРМ
      Parameters:
        `sormProject` - проект СОРМ, для которого необходимо начать выгрузку
        `withPayments` - с платежами или без
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getStatisticOfProject

          SearchResult<SormUploadStatistic> getStatisticOfProject(int sormProjectId,
                                                                  Page page)
                                                           throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### clearStatisticOfProject

          void clearStatisticOfProject(int sormProjectId)
                                throws ru.bitel.bgbilling.common.BGException

      Удаление статистики для проекта СОРМ
      Parameters:
        `sormProjectId` - - id проекта сорм, для которого будет удалена статистика выгрузок
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### tryUploadToFTPAgain

          void tryUploadToFTPAgain(SormUploadStatistic statistic)
                            throws ru.bitel.bgbilling.common.BGException

      Попытка снова выгрузить файлы на фтп для неудачной выгрузки.
      Parameters:
        `statistic` - - статистика неудавшейся выгрузки на фтп
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### listObjectType

          java.util.List<IdTitle> listObjectType()
                                          throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### listObjectParamsByObjectType

          java.util.List<IdTitle> listObjectParamsByObjectType(int objectTypeId)
                                                        throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`